/*
 * common.h - definitions used system-wide
 *   by uratan! 2014.10.23
 */
#ifndef __COMMON_H__
#define __COMMON_H__

/* =============================================================== */

/*
 * system-wide macros and typedefs
 */
#define NULL    ((void *)0)

// typedef-ed in lpc_types.h
//#define TRUE    1
//#define FALSE   0

typedef signed char    s_char;
typedef unsigned char  u_char;
typedef unsigned short u_short;
typedef unsigned long  u_long;

#define VOLATILE  volatile		/* enhance to look attractive */

/*
 * this attribute may be no more needed,
 * because the hardware saves registers out of function call ABI...
 */
//#define ATTR_INTR  __attribute__ ((interrupt))
#define ATTR_INTR

/* =============================================================== */

/*
 * for software timer (loop by VOLATILE u_long)
 */
#define LOOP_WAIT_1msec  3015		/* 1.0msec @ 30MHz, no-wait, -Os */
//#define LOOP_WAIT_1msec  2154		/* 1.0msec @ 30MHz,  1-wait, -Os */
//#define LOOP_WAIT_1msec  1210		/* 1.0msec @ 12MHz, no-wait, -Os */
//#define LOOP_WAIT_1msec   864		/* 1.0msec @ 12MHz,  1-wait, -Os */

/*
 * interrupt priorities
 *   0(highest) - 3(lowest)
 */
#define PRI_SYSTICK   1
#define PRI_UART1     2

/*
 * use PIO0_4 for time measuring (instead of U0_TxD)
 */
#define USE_DEBUG_OUTPUT   0
#define GPO_DEBUG     (1<<4)
#  define DEBUG_HIGH  LPC_GPIO_PORT->SET[0] = GPO_DEBUG
#  define DEBUG_LOW   LPC_GPIO_PORT->CLR[0] = GPO_DEBUG

/*
 * special charactors
 */
#define KEY_BS   0x08
#define KEY_LF   0x0a
#define KEY_CR   0x0d
#define KEY_ESC  0x1b
#define KEY_SPC  0x20

/* =============================================================== */

/*
 * shared functions
 */
/* in common.c */
extern void cm_init_uart(u_long baudrate, u_long mainCLK);
extern void cm_putchar(int ch);
extern int cm_keyin(void);
extern u_char cm_getchar(void);
/* in rprintf.c */
extern void rprintf(char const *format, ...);

/*
 * shared variables
 */
#ifdef __MAIN_C__
# define EXTERN
#else /* __MAIN_C__ */
# define EXTERN extern
#endif /* __MAIN_C__ */

//@@//#define SIZE_of_L_BUFF    256
//@@//EXTERN u_char l_buff[SIZE_of_L_BUFF];	/* for console line buffer */

#undef EXTERN


#endif /* __COMMON_H__ */
